package xyz.thastertyn.ContentDisplay;

import java.util.concurrent.atomic.AtomicBoolean;

import com.googlecode.lanterna.TerminalPosition;
import com.googlecode.lanterna.TerminalSize;
import com.googlecode.lanterna.gui2.Border;
import com.googlecode.lanterna.gui2.Borders;
import com.googlecode.lanterna.gui2.Label;
import com.googlecode.lanterna.gui2.Panel;
import com.googlecode.lanterna.gui2.Window;
import com.googlecode.lanterna.gui2.WindowBasedTextGUI;
import com.googlecode.lanterna.gui2.WindowListener;
import com.googlecode.lanterna.input.KeyStroke;
import com.googlecode.lanterna.input.KeyType;

import xyz.thastertyn.ContentDisplay.Content.JecnaContent;
import xyz.thastertyn.ContentDisplay.Content.OmluvnyList;
import xyz.thastertyn.ContentDisplay.Content.Rozvrh;
import xyz.thastertyn.ContentDisplay.Content.Sdeleni;
import xyz.thastertyn.ContentDisplay.Content.Znamky;

public class WindowSwitchListener implements WindowListener {

	WindowBasedTextGUI gui;

	private JecnaContent[] contents = {new Rozvrh(), new Znamky(), new Sdeleni(), new OmluvnyList()};
	private Border[] tabs = new Border[contents.length];

	private Panel tabsPanel;
	private Panel content;

	private String JsessionId;

	int current = 0;

	public WindowSwitchListener(Panel holder, String JsessionId, Panel tabs, String title)
	{
		this.content = holder;
		this.tabsPanel = tabs;
		this.JsessionId = JsessionId;
		addTabs();
		defaultPanel();
	}
	
	private void defaultPanel()
	{
		contents[0].download(JsessionId);
		content.removeAllComponents();
		content.addComponent(contents[0].getPanel());
	}

	public void next()
	{
		// tabs.getChildrenList().get(current).withBorder(Borders.singleLine());

		if(current + 1 == contents.length)
		{
			current = 0;
		}else{
			current++;
		}

		if(!contents[current].hasStarted())
		{
			contents[current].download(JsessionId);
		}

		// tabs[current].getComponent().withBorder(Borders.doubleLine());

		content.removeAllComponents();
		content.addComponent(contents[current].getPanel());

	}

	public void previous()
	{
		if(current - 1 == -1)
		{
			current = contents.length - 1;
		}else{
			current--;
		}

		if(!contents[current].hasStarted())
		{
			contents[current].download(JsessionId);
		}
		content.removeAllComponents();
		content.addComponent(contents[current].getPanel());
	}

	private void addTabs()
	{
		for(int i = 0; i < contents.length; i++)
		{
			tabs[i] = contents[i].getLabel();
			tabsPanel.addComponent(tabs[i]);
		}
	}
	
	@Override
	public void onInput(Window basePane, KeyStroke keyStroke, AtomicBoolean deliverEvent) {
		KeyType type = keyStroke.getKeyType();

		switch(type)
		{
			case Tab:
				if(!keyStroke.isShiftDown())
				{
					next();
				}else{
					previous();
				}
				break;
			default:
				break;
		}
	}

	@Override
	public void onUnhandledInput(Window basePane, KeyStroke keyStroke, AtomicBoolean hasBeenHandled) {
		// TODO Auto-generated method stub
	}

	@Override
	public void onResized(Window window, TerminalSize oldSize, TerminalSize newSize) {
		window.invalidate();
	}

	@Override
	public void onMoved(Window window, TerminalPosition oldPosition, TerminalPosition newPosition) {
		// TODO Auto-generated method stub
	}
	
}
